# coding: utf-8

# flake8: noqa

"""
    Unity Cloud Build

    This API is intended to be used in conjunction with the Unity Cloud Build service. A tool for building your Unity projects in the Cloud.  See https://developer.cloud.unity3d.com for more information.  ## Making requests This website is built to allow requests to be made against the API. If you are currently logged into Cloud Build you should be able to make requests without entering an API key.   You can find your API key in the Unity Cloud Services portal by clicking on 'Cloud Build Preferences' in the sidebar. Copy the API Key and paste it into the upper left corner of this website. It will be used in all subsequent requests.  ## Clients The Unity Cloud Build API is based upon Swagger. Client libraries to integrate with your projects can easily be generated with the [Swagger Code Generator](https://github.com/swagger-api/swagger-codegen).  The JSON schema required to generate a client for this API version is located here:  ``` [API_URL][BASE_PATH]/api.json ```  ## Authorization The Unity Cloud Build API requires an access token from your Unity Cloud Build account, which can be found by selecting **Settings** under **DevOps > Cloud Build** at https://dashboard.unity3d.com/cloud-build  To authenticate requests, include a Basic Authentication header with your API key as the value. e.g.  ``` Authorization: Basic [YOUR API KEY] ```  ## Pagination Paged results will take two parameters. A page number that is calculated based upon the per_page amount. For instance if there are 40 results and you specify page 2 with per_page set to 10 you will receive records 11-20.  Paged results will also return a Content-Range header. For the example above the content range header would look like this:  ``` Content-Range: items 11-20/40 ```  ## Versioning The API version is indicated in the request URL. Upgrading to a newer API version can be done by changing the path.  The API will receive a new version in the following cases:    * removal of a path or request type   * addition of a required field   * removal of a required field  The following changes are considered backwards compatible and will not trigger a new API version:    * addition of an endpoint or request type   * addition of an optional field   * removal of an optional field   * changes to the format of ids  ## Identifiers It should not be assumed that any of the identifiers used in paths will be a perfect match for your user-entered information. If you see unexpected 403s or 404s from API calls then check your identifiers match the ones used by the API. In particular, `projectId` does NOT typically change when the project is renamed and in fact may not be a direct match for the project name even at initial creation time.  To avoid confusion we recommend that instead of using the human-readable autogenerated orgId and projectId available from the API you should instead use:   * org foreign key for `orgId` (available from project APIs as `orgFk` and org APIs as `coreForeignKey`)   * `guid` for `projectId`  All links generated by the API and the Dashboard should follow this format already, making it easy to figure out the correct parameters by making a comparison.  ## Rate Limiting Requests against the Cloud Build API are limited to a rate of 100 per minute. To preserve the quality of service throughout Cloud Build, additional rate limits may apply to some actions. For example, polling aggressively instead of using webhooks or making API calls with a high concurrency may result in rate limiting.  It is not intended for these rate limits to interfere with any legitimate use of the API. Please contact support at <cloudbuild@unity3d.com> if your use is affected by this rate limit.  You can check the returned HTTP headers for any API request to see your current rate limit status.   * __X-RateLimit-Limit:__ maximum number of requests per minute   * __X-RateLimit-Remaining:__ remaining number of requests in the current window   * __X-RateLimit-Reset:__ time at which the current window will reset (UTC epoch seconds)  Once you go over the rate limit you will receive an error response: ``` HTTP Status: 429 {   \"error\": \"Rate limit exceeded, retry in XX seconds\" } ```   # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

# import apis into sdk package
from ucb_client.api.billing_api import BillingApi
from ucb_client.api.builds_api import BuildsApi
from ucb_client.api.buildtargets_api import BuildtargetsApi
from ucb_client.api.config_api import ConfigApi
from ucb_client.api.credentials_api import CredentialsApi
from ucb_client.api.orgs_api import OrgsApi
from ucb_client.api.projects_api import ProjectsApi
from ucb_client.api.public_api import PublicApi
from ucb_client.api.shares_api import SharesApi
from ucb_client.api.status_api import StatusApi
from ucb_client.api.userdevices_api import UserdevicesApi
from ucb_client.api.users_api import UsersApi
from ucb_client.api.webhooks_api import WebhooksApi

# import ApiClient
from ucb_client.api_client import ApiClient
from ucb_client.configuration import Configuration
# import models into sdk package
from ucb_client.models.inline_response200 import InlineResponse200
from ucb_client.models.inline_response2001 import InlineResponse2001
from ucb_client.models.inline_response20010 import InlineResponse20010
from ucb_client.models.inline_response20011 import InlineResponse20011
from ucb_client.models.inline_response20012 import InlineResponse20012
from ucb_client.models.inline_response2002 import InlineResponse2002
from ucb_client.models.inline_response2003 import InlineResponse2003
from ucb_client.models.inline_response2004 import InlineResponse2004
from ucb_client.models.inline_response2005 import InlineResponse2005
from ucb_client.models.inline_response2006 import InlineResponse2006
from ucb_client.models.inline_response2007 import InlineResponse2007
from ucb_client.models.inline_response2008 import InlineResponse2008
from ucb_client.models.inline_response2009 import InlineResponse2009
from ucb_client.models.options import Options
from ucb_client.models.options1 import Options1
from ucb_client.models.options10 import Options10
from ucb_client.models.options2 import Options2
from ucb_client.models.options3 import Options3
from ucb_client.models.options4 import Options4
from ucb_client.models.options5 import Options5
from ucb_client.models.options6 import Options6
from ucb_client.models.options7 import Options7
from ucb_client.models.options8 import Options8
from ucb_client.models.options9 import Options9
from ucb_client.models.orgsorgidcredentialssigningandroid_keystore import OrgsorgidcredentialssigningandroidKeystore
from ucb_client.models.orgsorgidcredentialssigningios_provisioning_profile import OrgsorgidcredentialssigningiosProvisioningProfile
from ucb_client.models.orgsorgidcredentialssigningosx_certificate import OrgsorgidcredentialssigningosxCertificate
from ucb_client.models.orgsorgidprojectsprojectidartifactsdelete_builds import OrgsorgidprojectsprojectidartifactsdeleteBuilds
from ucb_client.models.orgsorgidprojectsprojectidauditlog_lines import OrgsorgidprojectsprojectidauditlogLines
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_build_report import OrgsorgidprojectsprojectidbuildtargetsBuildReport
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_builds import OrgsorgidprojectsprojectidbuildtargetsBuilds
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_credentials import OrgsorgidprojectsprojectidbuildtargetsCredentials
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_credentials1 import OrgsorgidprojectsprojectidbuildtargetsCredentials1
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_credentials1_signing import OrgsorgidprojectsprojectidbuildtargetsCredentials1Signing
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_credentials_signing import OrgsorgidprojectsprojectidbuildtargetsCredentialsSigning
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_credentials_signing_credential_resource_ref import OrgsorgidprojectsprojectidbuildtargetsCredentialsSigningCredentialResourceRef
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_credentials_signing_credential_resource_ref_certificate import OrgsorgidprojectsprojectidbuildtargetsCredentialsSigningCredentialResourceRefCertificate
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_credentials_signing_credential_resource_ref_keystore import OrgsorgidprojectsprojectidbuildtargetsCredentialsSigningCredentialResourceRefKeystore
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_credentials_signing_credential_resource_ref_provisioning_profile import OrgsorgidprojectsprojectidbuildtargetsCredentialsSigningCredentialResourceRefProvisioningProfile
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_failure_details import OrgsorgidprojectsprojectidbuildtargetsFailureDetails
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_last_built import OrgsorgidprojectsprojectidbuildtargetsLastBuilt
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_links import OrgsorgidprojectsprojectidbuildtargetsLinks
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_project_version import OrgsorgidprojectsprojectidbuildtargetsProjectVersion
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings import OrgsorgidprojectsprojectidbuildtargetsSettings
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_advanced import OrgsorgidprojectsprojectidbuildtargetsSettingsAdvanced
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_advanced_android import OrgsorgidprojectsprojectidbuildtargetsSettingsAdvancedAndroid
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_advanced_unity import OrgsorgidprojectsprojectidbuildtargetsSettingsAdvancedUnity
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_advanced_unity_addressables import OrgsorgidprojectsprojectidbuildtargetsSettingsAdvancedUnityAddressables
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_advanced_unity_addressables_content_update_settings import OrgsorgidprojectsprojectidbuildtargetsSettingsAdvancedUnityAddressablesContentUpdateSettings
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_advanced_unity_asset_bundles import OrgsorgidprojectsprojectidbuildtargetsSettingsAdvancedUnityAssetBundles
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_advanced_unity_editor_user_build_settings import OrgsorgidprojectsprojectidbuildtargetsSettingsAdvancedUnityEditorUserBuildSettings
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_advanced_unity_player_exporter import OrgsorgidprojectsprojectidbuildtargetsSettingsAdvancedUnityPlayerExporter
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_advanced_unity_player_settings import OrgsorgidprojectsprojectidbuildtargetsSettingsAdvancedUnityPlayerSettings
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_advanced_unity_player_settings_android import OrgsorgidprojectsprojectidbuildtargetsSettingsAdvancedUnityPlayerSettingsAndroid
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_advanced_xcode import OrgsorgidprojectsprojectidbuildtargetsSettingsAdvancedXcode
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_build_schedule import OrgsorgidprojectsprojectidbuildtargetsSettingsBuildSchedule
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_platform import OrgsorgidprojectsprojectidbuildtargetsSettingsPlatform
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_settings_scm import OrgsorgidprojectsprojectidbuildtargetsSettingsScm
from ucb_client.models.orgsorgidprojectsprojectidbuildtargets_test_results import OrgsorgidprojectsprojectidbuildtargetsTestResults
from ucb_client.models.orgsorgidprojectsprojectidbuildtargetsbuildtargetidbuildsnumbersteps_messages import OrgsorgidprojectsprojectidbuildtargetsbuildtargetidbuildsnumberstepsMessages
from ucb_client.models.share_expiry import ShareExpiry
from ucb_client.models.share_expiry1 import ShareExpiry1
